using System.Net;
using System.Text;

namespace Tarpit;

public class ServerUtils
{
    private int _step = 0;
    
    public async Task ProcessRequestAsync(HttpListenerContext context)
    {
        HttpListenerResponse response = context.Response;
        
        response.ContentType = "text/html; charset=utf-8";
        
        Stream outputStream = response.OutputStream;
        
        int i = 0;
        while (true)
        {
            byte[] buffer = Encoding.UTF8.GetBytes(GetNextHtmlChunk());
            await outputStream.WriteAsync(buffer, 0, buffer.Length);
            await outputStream.FlushAsync();
            
            i++;
        }
        
        outputStream.Close();
    }
    
    string GetNextHtmlChunk()
    {
        Task.Delay(1).Wait();
        
        switch (_step)
        {
            case 0:
                _step++;
                return "<html><head><title>Progressive HTML</title></head><body><h1>Starting...</h1>";
            case 1:
                _step++;
                return "<p>This is the first paragraph.</p>";
            case 2:
                _step++;
                return "<p>Here's another paragraph with some <strong>bold text</strong>.</p>";
            case 3:
                _step++;
                return "<ul><li>Item 1</li><li>Item 2</li></ul>";
            case 4:
                _step++;
                return "<img src=\"https://via.placeholder.com/150\" alt=\"Placeholder Image\">";
            default:
                _step = 0;
                return "</body></html>";
        }
    }
}